
/* SC code for Corpi Sonori for flute, clarinet, cello and live electronics */
(
var prefs, s1, s2, notes, numOuts;
var fluteBuf, clarBuf, celloBuf, fluteS1Bus, fluteS2Bus, clarS1Bus, clarS2Bus, celloS1Bus, celloS2Bus, sumS1Bus, sumS2Bus;
var fluteIn, clarIn, celloIn, fluteS1In, fluteS2In, clarS1In, clarS2In, celloS1In, celloS2In;
var init, kill, bufTime, rBufTime, isPlaying, writeBufs;
var pevents;
var playbackPoint, filtCurChord, warpHarm, inHarm, barkDel, spot, spotBP, perc;
var scoreDisplay, slides, scorePages, scoreBasePath, lastPage, curPage, start;
var scoreWindow, evNumDisp, image, fraction, operation, bfBus1, bfBus2, decoder1, decoder2, grainBuf, s1Limit, s2Limit;

fraction = 1.0;
start = 0;

Server.default = s1 = Server.local;
s2 = Server.internal; // or s1

(s2 != s1).if({
	s2.options.memSize_(s1.options.memSize);
	s2.options.numOutputBusChannels_(s1.options.numOutputBusChannels);
	s2.options.numInputBusChannels_(s1.options.numInputBusChannels);
});
	
bufTime = 25 * 60;
rBufTime = bufTime.reciprocal;

z = prefs = PreferencePane.open(String.scDir +/+ "CopriSonoriPrefs.scd");

/* iPad stuff */


~evList = [
// \event nums		running \events
		[],
		[],
		[\ev2, \ev2a],
		[\ev2, \ev2a, \ev3],
		[\ev2a, \ev3, \ev4a],
		[\ev2a, \ev3, \ev4a],
		[\ev2a, \ev3, \ev4a],
		[\ev2a, \ev3, \ev4a, \ev7, \ev7a],
		[\ev2a, \ev3, \ev4a, \ev7, \ev7a, \ev8, \ev8a],
		[\ev2a, \ev3, \ev4a, \ev7a, \ev8, \ev8a, \ev9],
		[\ev2a, \ev3, \ev4a, \ev7a, \ev8, \ev8a, \ev9],
		[\ev2a, \ev3, \ev4a, \ev7a, \ev8, \ev8a, \ev9],
		[\ev2a, \ev3, \ev4a, \ev7a, \ev8, \ev8a, \ev9, \ev12, \ev12a],
		[\ev2a, \ev3, \ev4a, \ev7a, \ev8, \ev9, \ev12, \ev12a, \ev13],
		[\ev2a, \ev4a, \ev7a, \ev8, \ev9, \ev12a, \ev13, \ev14, \ev14a],
		[\ev2a, \ev4a, \ev7a, \ev8, \ev9, \ev12a, \ev13, \ev14, \ev14a],
		[\ev2a, \ev4a, \ev7a, \ev8, \ev9, \ev12a, \ev13, \ev14, \ev14a, \ev16],
		[\ev2a, \ev4a, \ev7a, \ev8, \ev9, \ev12a, \ev13, \ev14a, \ev16, \ev17, \ev17a, \ev17b],
		[\ev2a, \ev4a, \ev7a, \ev8, \ev9, \ev12a, \ev13, \ev14a, \ev16, \ev17, \ev17a, \ev17b, \ev18, \ev18a],
		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev13, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19, \ev19a, \ev19b],
		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19, \ev19a, \ev19b],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19, \ev19a, \ev19b, \ev21, \ev21a],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev21a, \ev22, \ev22a],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev22a],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev22a, \ev24, \ev24a, \ev24b],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev24, \ev24a, \ev24b],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev24, \ev24a, \ev24b, \ev26],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev24, \ev24a, \ev24b, \ev26],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev16, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev24, \ev24a, \ev24b, \ev26, \ev28],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev24, \ev24a, \ev24b, \ev26, \ev28, \ev29a, \ev29b, \ev29c, \ev29d],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev24, \ev24a, \ev24b, \ev26, \ev29a, \ev29b, \ev29c, \ev29d],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev17b, \ev18, \ev18a, \ev19a, \ev21, \ev22, \ev24, \ev24a, \ev24b, \ev26, \ev29a, \ev29b, \ev29c, \ev29d, \ev31a],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev17b, \ev18a, \ev19a, \ev24a, \ev24b, \ev29d, \ev31a, \ev32a, \ev32b],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a, \ev34, \ev34a],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a, \ev34, \ev34a, \ev35],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a, \ev34a, \ev35],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a, \ev34a, \ev35, \ev37a, \ev37b],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a, \ev34a, \ev35, \ev37a, \ev37b, \ev38],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a, \ev34a, \ev35, \ev37a, \ev37b, \ev38],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a, \ev34a, \ev35, \ev37a, \ev37b, \ev38],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a, \ev34a, \ev35, \ev37a, \ev37b, \ev38],
 		[\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a]
]; 

~evsAndDescriptions = [
	[\ev2, "PB Vc Ev1"],
	[\ev2a, "Reson Ev2"],
	[\ev3, "PB Vc Ev1"],
	[\ev4a, "Reson Ev4"],
	[\ev7, "PB Vc Ev6"],
	[\ev7a, "Reson Ev7"],
	[\ev8, "PB Vc Ev6"],
	[\ev8a, "PB Vc Ev7"],
	[\ev9, "Reson Ev9"],
	[\ev12, "PB Vc Ev11"],
	[\ev12a, "Reson Ev12"],
	[\ev13, "PB Vc Ev11"],
	[\ev14, "Pb Vc Ev13"],
	[\ev14a, "Reson Ev14"],
	[\ev16, "PB Vc Ev13"],
	[\ev17, "PB Vc Ev16"],
	[\ev17a, "Reson Ev17"],
	[\ev17b, "Bark Del"],
	[\ev18, "PB Vc Ev16"],
	[\ev18a, "Harm Clar"],
	[\ev19, "PB Vc Ev18"],
	[\ev19a, "Reson Ev19"],
	[\ev19b, "WarpHarm Ev7"],
	[\ev21, "PB Vc Ev 18"],
	[\ev21a, "WarpHarm Ev17"],
	[\ev22, "PB Vc Ev21"],
	[\ev22a, "WarpHarm, Ev12"],
	[\ev24, "Pb Vc Ev22"],
	[\ev24a, "WarpHarm Ev17"],
	[\ev24b, "BarkDel"],
	[\ev26, "PB Vc Ev25"],
	[\ev28, "PB Vc Ev26"],
	[\ev29a, "PB Vc Ev1"],
	[\ev29b, "PB Vc Ev6"],
	[\ev29c, "PB Vc Ev13"],
	[\ev29d, "Perc Sounds"],
	[\ev31a, "WarpHarm Ev12"],
	[\ev32a, "WarpHarm Ev2"],
	[\ev32b, "WarpHarm Ev17"],
	[\ev34, "PB Vc Ev 1"],
	[\ev34a, "spotBP"],
	[\ev35, "Harm Clar"],
	[\ev37a, "Harm Flute"],
	[\ev37b, "Harm Cello"],
	[\ev38, "Bark Del"]
];

~getIP = { arg action;
	var before = NetAddr.broadcastFlag;
	NetAddr.broadcastFlag = true;
	OSCresponder(nil, '/getMyIP', { arg t,r,msg,addr;
		action.(addr);
		NetAddr.broadcastFlag = before;
		r.remove;
	}).add;

	NetAddr("255.255.255.255", NetAddr.langPort).sendMsg('/getMyIP');
	nil;
};

~getIP.value({arg addr; ("Set the IP in TouchOSC to: " ++ addr.ip ++ " and port: "++NetAddr.langPort).postln});

~iPad = nil; // NetAddr("10.0.1.20", 58100);
~curEv = 0;
~checkAddr = {arg addr;
	~iPad.isNil.if({
		~iPad = NetAddr(addr.ip, 58100);
		~setupIPad.(0);
		~iPad.sendMsg('/1/master', 0.5);
		~iPad.sendMsg('/1/masterNum', 0);
		~curEv = 0;
	})
};

~evData = Dictionary.new;
~evsAndDescriptions.do({arg thisEv;
	var ev, desc;
	#ev, desc = thisEv;
	~evData.add(ev -> Dictionary.new);
	~evData[ev].add(\amp -> 0);
	~evData[ev].add(\id -> ev);
	~evData[ev].add(\desc -> desc);
});

~map = [-90, 12, \db].asSpec;

// ~map.map(0.5) // about 0 db at the halfway point!

~setupResponders = {
	~resps = 22.collect({arg i;
		var idx, fader;
		idx = i.asStringToBase(10, 2);
		[
			OSCresponderNode(nil, fader = ("/1/fader" ++ idx).asSymbol, {arg time, resp, msg, addr;
				var amp, numTag, ev, prefAmp, pm;
				~checkAddr.(addr);
				amp = ~map.map(msg[1]).round(0.001); // in db
				numTag = ("/1/num"++idx).asSymbol;
				~iPad.sendMsg(numTag, amp);
				ev = ~curEvs[i];
				~evData[ev][\amp] = amp;
				prefAmp = prefs[(ev++"Amp").asSymbol];
				pevents.eventDict[ev].amp_((prefAmp + amp).dbamp);
			}).add,
			OSCresponderNode(nil, ("/1/fader" ++ idx ++ "/z").asSymbol, {arg time, resp, msg, addr;
				var amp, numTag;
				~checkAddr.(addr);
				~iPad.sendMsg((fader ++ "/color").asSymbol, (msg[1] == 1).if({"green"}, {"purple"}));
			}).add		
		]
	});
	~resps = ~resps.add(
		OSCresponderNode(nil, '/1/master/z', {arg time, resp, msg, addr;
			~checkAddr.(addr);
			~iPad.sendMsg(("/1/master/" ++ "/color").asSymbol, (msg[1] == 1).if({"green"}, {"purple"}));
		}).add;
	);
	~resps = ~resps.add(
		OSCresponderNode(nil, '/1/master', {arg time, resp, msg, addr;
			var amp;
			amp = ~map.map(msg[1]).round(0.001);
			~checkAddr.(addr);
			~iPad.sendMsg('/1/masterNum', amp);
			s1Limit.amp_(amp.dbamp);
			(s1 != s2).if({
				s2Limit.amp_(amp.dbamp)
			});
		}).add;
	);
	~resps = ~resps.add(
		OSCresponderNode(nil, '/1', {arg time, resp, msg, addr;
			~checkAddr.(addr);
		}).add;
	);
	~resps = ~resps.add(
		OSCresponderNode(nil, '/1/Next', {arg time, resp, msg, addr;
			~checkAddr.(addr);
			(msg[1] == 1).if({
				~curEv = ~curEv + 1;
				~setupIPad.(~curEv - 1);
				{pevents.next}.defer;
			});
		}).add;
	);
	~resps = ~resps.add(
		OSCresponderNode(nil, '/1/Back', {arg time, resp, msg, addr;
			~checkAddr.(addr);
			(msg[1] == 1).if({
				~curEv = ~curEv - 1;
				pevents.index_(~curEv);
				~iPad.sendMsg('/1/nextEv', ~curEv);
			});
		}).add;
	);
	~resps = ~resps.add(
		OSCresponderNode(nil, '/1/Forward', {arg time, resp, msg, addr;
			~checkAddr.(addr);
			(msg[1] == 1).if({
				~curEv = ~curEv + 1;
				pevents.index_(~curEv);
				~iPad.sendMsg('/1/nextEv', ~curEv);
			});
		}).add;
	);
};

~setupResponders.value; 
~removeResponders = {
	~resps.flat.do({arg me; me.remove});
	};

~curEvs = [];

~setupIPad = {arg ev;
	~curEvs = [];
	~iPad.sendBundle(0.1, 
		['/1/curEv', ev], 
		['/1/nextEv', ev + 1]
	);
	~evList[ev].do({arg thisEv, i;
		var faderTag, labelTag, numTag, idx;
		~curEvs = ~curEvs.add(thisEv);
		idx = i.asStringToBase(10,2);
		faderTag = ("/1/fader" ++ idx).asSymbol;
		labelTag = ("/1/label" ++ idx).asSymbol;
		numTag = ("/1/num" ++ idx).asSymbol;
		~iPad.sendBundle(0.1, 
			[faderTag, ~map.unmap(~evData[thisEv][\amp])],
			[labelTag, ~evData[thisEv][\desc]],
			[numTag, ~evData[thisEv][\amp]],
			[faderTag ++ "/visible", "true"], 
			[labelTag ++ "/visible", "true"], 
			[numTag ++ "/visible", "true"]
		);
	});
	(22 - ~curEvs.size).do({arg i;
		var faderTag, labelTag, numTag, idx;
		idx = 21 - i;
		idx = idx.asStringToBase(10, 2);
		faderTag = ("/1/fader" ++ idx ++ "/visible").asSymbol;
		labelTag = ("/1/label" ++ idx ++ "/visible").asSymbol;
		numTag = ("/1/num" ++ idx ++ "/visible").asSymbol;
		~iPad.sendBundle(0.1, 
			[faderTag, "false"], [labelTag, "false"], [numTag, "false"]
		);
	});
};

/* 

~iPad.sendMsg('/1/label21/visible', "false")
~iPad
~removeResponders.value
~curEvs
~setupIPad.value(31)
~evList[31]
Routine.run({
	(~evList.size - 1).do({arg me;
		~setupIPad.value(me.postln);
	0.5.wait;
	})
})
*/

/* end iPad */

writeBufs = false; // true;

n = notes = CtkProtoNotes(
	SynthDef(\CSinput, {arg gate = 1, inbus, outbus, amp = 1, sumOut;
		var env, in;
		env = EnvGen.kr(Env([0, 1, 0], [0.1, 0.1], \sin, 1), gate, doneAction: 2);
		in = Limiter.ar(In.ar(inbus, 1) * amp * env, 0.5);
		Out.ar(outbus, in);
		Out.ar(sumOut, in * 0.333);
		}),
	SynthDef(\CSinputRec, {arg gate = 1, buffer, startPos = 0, inbus, outbus, amp = 1, sumOut;
		var env, in;
		env = EnvGen.kr(Env([0, 1, 0], [0.1, 0.1], \sin, 1), gate, doneAction: 2);
		in = Limiter.ar(In.ar(inbus, 1) * amp * env, 0.5);
		RecordBuf.ar(in, buffer, offset: startPos * SampleRate.ir);
		Out.ar(outbus, in);
		Out.ar(sumOut, in * 0.333);
		}),
	SynthDef(\CSLimitScale, {arg gate = 1, inbus, amp = 1, lag = 1;
		var in, env;
		env = EnvGen.kr(Env([0, 1, 0], [1, 1], \sin, 1), gate, doneAction: 2);
		in = In.ar(inbus, 8);
		in = Limiter.ar(in);
		ReplaceOut.ar(inbus, in * (Lag2.kr(amp, lag)));
		}),
	// figure out a way to do this with a specific moment and no warps, 
	// then it can be used on s2
	SynthDef(\CSfiltChordPastMoment, {arg gate = 1, inbus, flBuf, clBuf, vcBuf, fftBuf1, fftBuf2, 
			tPoint, randInSecs, randRate = 0.1, outbus, rBufSecs, loc, spread;
		var point, chain1, chain2, flute, clar, cello, src, filt, filtOut, rev, inEnv, outEnv, 
			l, r;
		spread = spread * 0.5;
		inEnv = EnvGen.kr(Env([0, 1, 0], [1, 1], \sin, 1), gate);
//		outEnv = EnvGen.kr(Env([0, 1, 0], [1, 10], \sin, 1), gate, doneAction: 2);
		src = LeakDC.ar(In.ar(inbus, 1)) * inEnv;
		point = LFNoise2.kr(randRate).range(randInSecs) + tPoint * rBufSecs;
		flute = WarpZ.ar(1, flBuf, point, 1, 0.11, -1, 6, 0.1, 1, 0.01, 0.1);
		clar = WarpZ.ar(1, clBuf, point, 1, 0.11, -1, 6, 0.1, 1, 0.01, 0.1);
		cello = WarpZ.ar(1, vcBuf, point, 1, 0.11, -1, 6, 0.1, 1, 0.01, 0.1);
		filt = LeakDC.ar(flute + clar + cello);
		chain1 = FFT(fftBuf1, src);
		// if needed, enhance upper bins of chain2 for higher partials
		chain2 = FFT(fftBuf2, filt);
		chain1 = PV_SpectralMap(chain1, chain2, 0.0, 0, 1, 1);
		filt = filt + HPF.ar(HPF.ar(HPF.ar(filt, 1000), 1000, 10), 20); 
		filtOut = IFFT(chain1) * 36.dbamp;
		rev = LeakDC.ar(GVerb.ar(filtOut, 140, 8));
		filtOut = LeakDC.ar(Spreader.ar(filtOut));
		l = BFEncode1.ar(filtOut[0] + rev[0], loc - spread);
		r = BFEncode1.ar(filtOut[1] + rev[1], loc + spread);
		Out.ar(outbus, l + r);
		}),
	SynthDef(\CSfiltChordCurMoment, {arg gate = 1, inbus, flIn, clIn, vcIn, fftBuf1, fftBuf2, 
			outbus, loc, spread;
		var point, chain1, chain2, flute, clar, cello, src, filt, filtOut, rev, inEnv, outEnv, 
			l, r, dummy;
		spread = spread * 0.5;
		inEnv = EnvGen.kr(Env([0, 1, 0], [1, 1], \sin, 1), gate);
		src = LeakDC.ar(In.ar(inbus, 1)) * inEnv;
		flute = In.ar(flIn, 1);
		clar = In.ar(clIn, 1);
		cello = In.ar(vcIn, 1);
		filt = LeakDC.ar(PitchShift.ar(flute + clar + cello, 0.11, 0.95, 0, 0.01));
		// if needed, enhance upper bins of chain2 for higher partials
		filt = filt + HPF.ar(HPF.ar(HPF.ar(filt, 1000, 3.dbamp), 1000, 1), 1000); 
		chain1 = FFT(fftBuf1, src);
		chain2 = FFT(fftBuf2, filt);
		chain1 = PV_SpectralMap(chain1, chain2, 0.0, Line.kr(-1, 1, 2), 1, 1);
		filtOut = Limiter.ar(
			CompanderD.ar(IFFT(chain1) * 48.dbamp, 
				0.125, 1, 0.2, 0.01, 2),
			-12.dbamp, 0.01);
		rev = LeakDC.ar(GVerb.ar(filtOut, 140, 8, drylevel: 0.5));
		l = BFEncode1.ar(filtOut + rev.sum, loc);
		Out.ar(outbus, l);
		}),
	SynthDef(\CSplaybackPoint, {arg buffer, outbus, pan, panRand, grainDur, grainDurRand,
			grainRate, grainRateRand, playPos, playPosRand, rBufSecs, envbuf = -1;
		var trig, loc, grains, dur, pos, env;
		trig = Impulse.kr(LFNoise1.kr(0.2, grainRateRand, grainRate));
		loc = TRand.kr(pan - panRand, pan + panRand, trig);
		dur = TRand.kr(grainDur * (1 - grainDurRand), grainDur * (1 + grainDurRand), trig);
		pos = TRand.kr(playPos, playPosRand, trig) * rBufSecs;
		grains = BufGrainBBF.ar(trig, dur, buffer, 1, pos, envbuf, loc, 0, 1, 1);
//		grains = GrainBuf.ar(2, trig, dur, buffer, 1, 0, 1, loc, envbuf);
		Out.ar(outbus, grains * -12.dbamp);
		}),
	SynthDef(\CSplaybackChase, {arg buffer, outbus, pan, panRand, grainDur, grainDurRand,
			grainRate, grainRateRand, playPos, playPosRand, rBufSecs, envbuf = -1;
		var trig, loc, grains, dur, pos, env;
		trig = Impulse.kr(LFNoise1.kr(0.2, grainRateRand, grainRate));
		loc = TRand.kr(pan - panRand, pan + panRand, trig);
		dur = TRand.kr(grainDur * (1 - grainDurRand), grainDur * (1 + grainDurRand), trig);
		pos = (TRand.kr(playPos, playPosRand, trig) + Sweep.kr(1, 1)) * rBufSecs;
		grains = BufGrainBBF.ar(trig, dur, buffer, 1, pos, envbuf, loc, 0, 1, 1);
		Out.ar(outbus, grains);
		}),
	// pan to -1 for mono routing
	SynthDef(\CSpshiftWin, {arg inbus, outbus, pan = 0, noteDur = 1, level = 1, pshift = 1;
		var in, ps, env, envGen;
		env = Control.names([\env]).kr(Env.newClear(8).asArray);
		envGen = EnvGen.kr(env, timeScale: noteDur, levelScale: level, doneAction: 2);
		in = In.ar(inbus, 1);
		ps = PitchShift.ar(in, 0.11, pshift, 0, 0.02);
		Out.ar(outbus, BFEncode1.ar(ps * envGen, pan));
		}),
	SynthDef(\CSpshift, {arg gate = 1, inbus, outbus, pan = 0, level = 1, pshift = 1;
		var in, ps, env, envGen;
		env = Control.names([\env]).kr(Env.newClear(8).asArray);
		envGen = EnvGen.kr(env, gate, levelScale: level, doneAction: 2);
		in = In.ar(inbus, 1);
		ps = PitchShift.ar(in, 0.11, pshift, 0, 0.02);
		Out.ar(outbus, BFEncode1.ar(ps * envGen, pan));
		}),
	SynthDef(\CSperc, {arg outbus, buffer, rate = 1, starttime = 0, centerfreq = 440, amp, dur,
			srcBoost = 1, loc;
		var src, amptrack, noise, envTrack, filt, env, envgen;
		src = PlayBuf.ar(1, buffer, rate, 1, starttime * BufSampleRate.kr(buffer)); // * srcBoost;
		env = Control.names([\env]).kr(Env.newClear.asArray);
		envgen = EnvGen.kr(env, doneAction: 2, timeScale: dur);
		envTrack = Amplitude.ar(src).max(0.001);
		noise = Resonz.ar(LPF.ar(GrayNoise.ar, 1000 + (4000 * envTrack)) * envTrack, 
			centerfreq * [0.49, 0.7, 1, 2.03, 4.2], 0.01).sum;
		Out.ar(outbus, BFEncode1.ar((noise * envgen), loc));
		}),
	// can be used to stretch a moment -> also, feed into windowed pitchShifts;
	SynthDef(\CSwarpMoment, {arg gate = 1, outbus, pan = 1, buf1, buf2, buf3, pointStart, pointEnd;
		var warp, point;
		point = LFNoise2.kr(0.1).range(pointStart, pointEnd).dup(3);
		warp = WarpZ.ar(1, [buf1, buf2, buf3], point, 1, 0.11, -1, 6, 0.1, 1, 0.01, 0.01).sum;
		Out.ar(outbus, BFEncode1.ar(warp, pan));
		}),
	// an EQd version of spotlight
	SynthDef(\CSspotlight, {arg buffer, loc, startPos, rate, pShift = 1, dur, outbus;
		var point, cf, cfgen, width, widthgen, mono, filt, gvl, gvr, locSpread;
		point = Line.kr(startPos, startPos + (dur * rate), dur) / BufDur.kr(buffer);
		mono = WarpZ.ar(1, buffer, point, pShift, 0.11, -1, 6, 0.1, 4, 0.01, 0.01); 
		cf = EnvGen.kr(
			Control.names([\cf]).kr(Env.newClear(4)), timeScale: dur);
		width = EnvGen.kr(
			Control.names([\width]).kr(Env.newClear(4)), timeScale: dur);
		filt = BPeakEQ.ar(mono * 0.01, (cf * LFNoise2.kr(0.2).range(0.95, 1.05).dup(4)) * 
			[0, 3, 5, 7].midiratio, width, 60).sum;
		filt = filt + BPeakEQ.ar(mono * 0.01, cf * [0, 3, 5, 7].midiratio, width * 10, 24).sum;
		#gvl, gvr = GVerb.ar(filt, 140, 6, spread: 45, maxroomsize: 141);
		locSpread = LFNoise1.kr(0.1).range(0.05, 0.15);
		Out.ar(outbus, BFEncode1.ar(gvl, loc - locSpread) + BFEncode1.ar(gvr, loc + locSpread) *
			EnvGen.kr(Control.names([\env]).kr(Env.newClear(8)), timeScale: dur, doneAction: 2))
		}),
	// bandpassed version
	SynthDef(\CSspotlightBP, {arg buffer1, buffer2, buffer3, loc, startPos, rate, pShift = 1, 
			dur, outbus, amp = 1, cf, width;
		var point, mono, filt, gvl, gvr, locSpread;
		point = Line.kr(startPos, startPos + (dur * rate), dur) / BufDur.kr(buffer1);
		mono = WarpZ.ar(1, [buffer1, buffer2, buffer3], point, pShift, 0.11, -1, 6, 0.1, 4, 
			0.01, 0.01).sum; 
		cf = cf * LFNoise2.kr(0.05).range(0.95, 1.02);
		width = width * LFNoise2.kr(0.05).range(0.95, 1.02);
		filt = BBandPass.ar(mono * 0.01, (cf * LFNoise2.kr(0.2).range(0.95, 1.05).dup(4)) * 
			[0, 3, 5, 7].midiratio, width, 60).sum;
		filt = filt + BBandPass.ar(mono * 0.01, cf * [0, 3, 5, 7].midiratio, width, 24).sum;
		#gvl, gvr = GVerb.ar(filt, 140, 6, spread: 90, maxroomsize: 141);
		locSpread = LFNoise1.kr(0.1).range(0.05, 0.15);
		Out.ar(outbus, BFEncode1.ar(gvl, loc - locSpread) + 
			BFEncode1.ar(gvr, loc + locSpread) * amp *
			EnvGen.kr(Control.names([\env]).kr(Env.newClear(8)), timeScale: dur, doneAction: 2))		}),	
	SynthDef(\CSbarkDel, {arg gate = 1, timeScale = 1, inbus, outbus, loc, 
			width = 0.9, freqmul = 0.95, maxdel = 1;
		var in, out, env, deltimes, feedback, bd, amps;
		env = Control.names([\env]).kr(Env.newClear(4).asArray);
		deltimes = Control.names([\deltimes]).kr(Array.fill(25, {0.5.rrand(1.0)}));
		feedback = Control.names([\feedback]).kr(Array.fill(25, {0.7.rrand(0.9)}));
		amps = Control.names([\amps]).kr(Array.fill(25, {1}));
		in = PitchShift.ar(In.ar(inbus), 0.11, freqmul, 0, 0.01);
		bd = BarkDelay.ar(in, deltimes, feedback, amps, maxdel, width, freqmul);
		Out.ar(outbus, 
			BFEncode1.ar(bd.sum * 
					EnvGen.kr(env, gate, timeScale: timeScale, doneAction: 2), 
				loc));
		})
	);

notes.load(s1);
notes.load(s2);

isPlaying = false;

numOuts = s1.options.numOutputBusChannels;

scoreDisplay = 1; //prefs[\scoreDisplay];
(scoreDisplay > 0).if({
	scoreBasePath = String.scDir ++ "/Tiffs/CorpiSonori-";
	slides = (1..11).collect({arg thisImg; 
		var pic;
		thisImg = thisImg.asStringToBase(10, 2);
		thisImg.postln;
		pic = SCImage.new(scoreBasePath++thisImg++".tif");
		pic.scalesWhenResized_(true);
		});
	scorePages = [1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 5, 5, 5, 6, 6, 6, 6,
		7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 11, 11];
	curPage = scorePages[start];
	});
	
fluteIn = prefs[\fluteIn] + numOuts;
clarIn = prefs[\clarIn] + numOuts;
celloIn = prefs[\celloIn] + numOuts;

/* assign actions to the preferences */

prefs.prefsDict[\fluteIn].action_({arg newVal;
	isPlaying.if({
		fluteS1In.inbus_(newVal + numOuts);
		fluteS2In.inbus_(newVal + numOuts);
		})
	});

prefs.prefsDict[\clarIn].action_({arg newVal;
	isPlaying.if({
		clarS1In.inbus_(newVal + numOuts);
		clarS2In.inbus_(newVal + numOuts);
		})
	});
	
prefs.prefsDict[\celloIn].action_({arg newVal;
	isPlaying.if({
		celloS1In.inbus_(newVal + numOuts);
		celloS2In.inbus_(newVal + numOuts);
		})
	});

prefs.prefsDict[\fluteAmpScale].action_({arg newVal;
	isPlaying.if({
		fluteS1In.amp_(newVal.dbamp);
		fluteS2In.amp_(newVal.dbamp);
		})
	});

prefs.prefsDict[\clarAmpScale].action_({arg newVal;
	isPlaying.if({
		clarS1In.amp_(newVal.dbamp);
		clarS2In.amp_(newVal.dbamp);
		})
	});
	
prefs.prefsDict[\celloAmpScale].action_({arg newVal;
	isPlaying.if({
		celloS1In.amp_(newVal.dbamp);
		celloS2In.amp_(newVal.dbamp);
		})
	});

/* boot the servers */		
s1.boot;
s2.boot;


/* the main routine */
Routine.run({
	var cond;
	cond = Condition.new;
	s1.waitForBoot({
		s2.waitForBoot({
			/* init the buffers and audio busses */
			grainBuf = CtkBuffer.buffer(1024, server: s1)
				.fillWithEnv(0.1, Env([0, 1, 0], [0.5, 0.5], \sin)).load;
			s1.sync;
			fluteBuf = CtkBuffer.buffer(bufTime * s1.sampleRate, server: s1).load;
			clarBuf = CtkBuffer.buffer(bufTime * s1.sampleRate, server: s1).load;
			celloBuf = CtkBuffer.buffer(bufTime * s1.sampleRate, server: s1).load;
			bfBus1 = CtkAudio.new(4, server: s1);
			fluteS1Bus = CtkAudio.new(server: s1);
			clarS1Bus = CtkAudio.new(server: s1);
			celloS1Bus = CtkAudio.new(server: s1); 
			sumS1Bus = CtkAudio.new(server: s1);
			decoder1 = AmbDecoderGUI(server: s1)
				.addInput(bfBus1.bus, bfBus1.bus+1, bfBus1.bus+2, bfBus1.bus+3)
				.addOutput(0, 0.125, 0)
				.addOutput(1, -0.125, 0)
				.addOutput(2, 0.35, 0)
				.addOutput(3, -0.35, 0)
				.addOutput(4, 0.65, 0)
				.addOutput(5, -0.65, 0)
				.addOutput(6, 0.875, 0)
				.addOutput(7, -0.875, 0);
			(s1 != s2).if({
				bfBus2 = CtkAudio.new(4, server: s2);
				fluteS2Bus = CtkAudio.new(server: s2);
				clarS2Bus = CtkAudio.new(server: s2);
				celloS2Bus = CtkAudio.new(server: s2);
				sumS2Bus = CtkAudio.new(server: s2);
				decoder2 = AmbDecoderGUI(bounds: Rect(500, 50, 800, 400), server: s2)
					.addInput(bfBus2.bus, bfBus2.bus+1, bfBus2.bus+2, bfBus2.bus+3)
					.addOutput(0, 0.125, 0)
					.addOutput(1, -0.125, 0)
					.addOutput(2, 0.35, 0)
					.addOutput(3, -0.35, 0)
					.addOutput(4, 0.55, 0)
					.addOutput(5, -0.55, 0)
					.addOutput(6, 0.875, 0)
					.addOutput(7, -0.875, 0);
				}, {
				"Same server".postln;
				fluteS2Bus = fluteS1Bus;
				clarS2Bus = clarS1Bus;
				celloS2Bus = celloS1Bus;
				sumS2Bus = sumS1Bus;
				g = [fluteS1Bus, clarS2Bus, celloS1Bus, sumS1Bus];
				});
			s1.sync(cond);
			"Buffers loaded".postln;
			
			/* ProcMods */
			init = ProcMod.new.function_({
				Routine({
					"Started".postln;
					isPlaying = true;
					fluteS1In = notes[\CSinputRec].new(server: s1, target: 0, addAction: 0)
						.inbus_(fluteIn).amp_(prefs[\fluteAmpScale].dbamp)
						.outbus_(fluteS1Bus).buffer_(fluteBuf).sumOut_(sumS1Bus).play;
					clarS1In = notes[\CSinputRec].new(server: s1, target: 0, addAction: 0)
						.inbus_(clarIn).amp_(prefs[\clarAmpScale].dbamp)
						.outbus_(clarS1Bus).buffer_(clarBuf).sumOut_(sumS1Bus).play;
					celloS1In = notes[\CSinputRec].new(server: s1, target: 0, addAction: 0)
						.inbus_(celloIn).amp_(prefs[\celloAmpScale].dbamp)
						.outbus_(celloS1Bus).buffer_(celloBuf).sumOut_(sumS1Bus).play;
					{decoder1.playGUI}.defer;
					(s1 != s2).if({
						fluteS2In = notes[\CSinput].new(server: s2, target: 0, addAction: 0)
							.inbus_(fluteIn).amp_(prefs[\fluteAmpScale].dbamp)
							.outbus_(fluteS2Bus).sumOut_(sumS2Bus).play;
						clarS2In = notes[\CSinput].new(server: s2, target: 0, addAction: 0)
							.inbus_(clarIn).amp_(prefs[\clarAmpScale].dbamp)
							.outbus_(clarS2Bus).sumOut_(sumS2Bus).play;
						celloS2In = notes[\CSinput].new(server: s2, target: 0, addAction: 0)
							.inbus_(celloIn).amp_(prefs[\celloAmpScale].dbamp)
							.outbus_(celloS2Bus).sumOut_(sumS2Bus).play;
						{decoder2.playGUI}.defer;	
						}, {
						fluteS2In = fluteS1In;
						clarS2In = clarS1In;
						celloS2In = celloS1In;
						});
					1.wait;
					s1Limit = notes[\CSLimitScale].new(server: s1,
						addAction: \tail, target: 0).inbus_(0).play;
					(s1 != s2).if({
						s2Limit = notes[\CSLimitScale].new(server: s2,
						addAction: \tail, target: 0).inbus_(0).play; 
					})
				});
			});
			kill = ProcMod.new.function_({
				[fluteS1In, fluteS2In, clarS1In, 
					clarS2In, celloS1In, celloS2In, fluteS1Bus, fluteS2Bus, clarS1Bus, 
					clarS2Bus, celloS1Bus, celloS2Bus, sumS1Bus, sumS2Bus, bfBus1, 
					bfBus2, grainBuf].do({arg me;
						me.free;
						});
				decoder1.window.close;
				decoder2.notNil.if({
					decoder2.window.close;
				});
				s1Limit.release;
				(s1 != s2).if({
					s2Limit.release
				});
				(scoreDisplay > 0).if({
					slides.do({arg thisImg; thisImg.free});
					scoreWindow.isClosed.not.if({
						scoreWindow.close
						});
					});
				~removeResponders.value;
				writeBufs.if({
					
					SystemClock.sched(0.1, {
						Routine.run({
							var stamp;
							stamp = Date.getDate.stamp;
							fluteBuf.write(path: ("~/Desktop/Recs/"++Date.getDate.stamp++"flute.aif").standardizePath, sampleFormat: "float");
							s1.sync(cond);
							clarBuf.write(path: ("~/Desktop/Recs/"++Date.getDate.stamp++"clar.aif").standardizePath, sampleFormat: "float");
							s1.sync(cond);
							celloBuf.write(path: ("~/Desktop/Recs/"++Date.getDate.stamp++"cello.aif").standardizePath, sampleFormat: "float");
							s1.sync(cond);
							"Written".postln;
							[fluteBuf, clarBuf, celloBuf].do({arg me;
								me.free;
								});
							})
						})
					}, {
					[fluteBuf, clarBuf, celloBuf].do({arg me;
						me.free;
						});
					});	
				});
			
			// playPoint and pointRand are time stamps from pevents
			playbackPoint = {arg id, amp, env, outbus, buffer, playPoint, pointRand;
				ProcModR(env, amp, 4, outbus, id, server: s1)
					.function_({arg group, routebus, server, pm;
						playPoint = pevents.stamp(playPoint);
						notes[\CSplaybackPoint].new(target: group, server: server)
							.buffer_(buffer).outbus_(routebus).pan_(0).panRand_(pi)
							.grainDur_(16).grainDurRand_(0.2).grainRate_(0.25)
							.grainRateRand_(0.2).playPos_(playPoint)
							.playPosRand_(pointRand).rBufSecs_(rBufTime)
							.envbuf_(grainBuf).play;
						})
				};
			
			// make sure 'delay' is in the global Env as well
			filtCurChord = {arg id, amp, env, outbus, inbus, loc = 0, delay = 1, serverIn;
				ProcModR(env, amp, 4, outbus, id, addAction: 1, target: 1, server: serverIn)
					.function_({arg group, routebus, server, pm;
						Task({
							var fft1, fft2;
							fft1 = CtkBuffer.buffer(4096, server: server).load;
							fft2 = CtkBuffer.buffer(4096, server: server).load;
							pm.releaseFunc_({
								SystemClock.sched(1.0, {
									fft1.free; fft2.free; ("FFT bufs freed for"+id).postln;
									})
								});
							server.sync;
							delay.wait;
							notes[\CSfiltChordCurMoment].new(target: group, server: server)
								.inbus_(inbus).flIn_(fluteS1Bus).clIn_(clarS2Bus)
								.vcIn_(celloS2Bus).fftBuf1_(fft1).fftBuf2_(fft2)
								.outbus_(routebus)
								.loc_(loc * pi).spread_(0.25).play;
							})	
						})
				};
			
			// loc and harms can be single values or patterns
			/* oooh! cool: Env([0, 1, 0], [10, 10]).asStream + Pwhite(0.0, 0.1).asStream 
				can work for .asStream parameters!
			*/
			warpHarm = {arg id, amp, env, outbus, playPoint, pointRandSecs, loc, harms, overlaps,
					winDur;
				ProcModR(env, amp, 4, bfBus1.bus, id, addAction: 0, target: 1, server: s1)
					.function_({arg group, routebus, server, pm;
						Task({
							var src, route, start, end, wait, next, noteDur;
							route = CtkAudio.new(2, server: server).play;
							pm.releaseFunc_({route.free});
							start = pevents.stamp(playPoint);
							end = (start + pointRandSecs) * rBufTime;
							start = start * rBufTime;
							loc = loc.asStream;
							harms = harms.asStream;
							overlaps = overlaps.asStream;
							winDur = winDur.asStream;
							src = notes[\CSwarpMoment].new(target: group, server: server)
								.outbus_(route).pan_(-1).buf1_(fluteBuf).buf2_(clarBuf)
								.buf3_(celloBuf).pointStart_(start).pointEnd_(end).play;
							// the windows that do the pitchShifting - remember the env
							loop({
								next = (noteDur = winDur.next) / overlaps.next;
								notes[\CSpshiftWin].new(addAction: 1, target: group, 
										server: server)
									.inbus_(route).outbus_(routebus).pan_(loc.next * 0.5pi)
									.noteDur_(noteDur).pshift_(harms.next.midiratio)
									.env_(Env([0, 1, 1, 0], [0.2, 0.6, 0.2], \sin)).play;
								next.wait;
								})
							})
						})
				};

			inHarm = {arg id, amp, env, outbus, inbus, pointRandSecs, loc, harms, overlaps,
					winDur;
				ProcModR(env, amp, 4, bfBus2.bus, id, addAction: 0, target: 1, server: s2)
					.function_({arg group, routebus, server, pm;
						Task({
							var src, route, wait, next, noteDur;
							route = CtkAudio.new(2, server: server).play;
							pm.releaseFunc_({route.free});
							loc = loc.asStream;
							harms = harms.asStream;
							overlaps = overlaps.asStream;
							winDur = winDur.asStream;
							// the windows that do the pitchShifting - remember the env
							loop({
								next = (noteDur = winDur.next) / overlaps.next;
								notes[\CSpshiftWin].new(addAction: 1, target: group, 
										server: server)
									.inbus_(inbus).outbus_(routebus).pan_(loc.next * 0.5pi)
									.noteDur_(noteDur).pshift_(harms.next.midiratio)
									.env_(Env([0, 1, 1, 0], [0.2, 0.6, 0.2], \sin)).play;
								next.wait;
								})
							})
						});
					};
			
			// winDur, overlaps, freqMul and loc can be values or patterns
			barkDel = {arg id, amp, env, outbus, inbus, winDur, overlaps, freqMul, loc, 
					width = 0.5;
				ProcModR(env, amp, 4, bfBus2.bus, id, server: s2)
					.function_({arg group, routebus, server, pm;
						Task({
							var next, noteDur, times, amps, fb, winEnv;
							winDur = winDur.asStream;							overlaps = overlaps.asStream;
							freqMul = freqMul.asStream;
							loc = loc.asStream;
							width = width.asStream;
							winEnv = Env([0, 1, 1, 0], [0.2, 0.6, 0.2], \sin);
							loop({
								next = (noteDur = winDur.next) / overlaps.next;
								times = Array.fill(25, {0.25.rrand(0.55)});
								amps = Array.fill(25, {arg i; 0.5 + (i * 0.01).rand});
								fb = Array.fill(25, {arg i; 0.45 + (i * 0.02).rand});
								notes[\CSbarkDel].new(target: group, server: server)
									.timeScale_(noteDur).inbus_(inbus).outbus_(routebus)
									.loc_(loc.next * 0.5pi)
									.width_(width.next).freqmul_(freqMul.next)
									.maxdel_(0.6).env_(winEnv).deltimes_(times)
									.feedback_(fb).amps_(amps).play;
								next.wait;
								})
						})
					})
				};
			
			perc = {arg id, amp, env, outbus, buffer, startPoints, loc, rates, winDur, 
					overlaps, baseFreq, freqMul;
				ProcModR(env, amp, 4, bfBus1.bus, id, server: s1)
					.function_({arg group, routebus, server, pm;
						Task({
							var next, noteDur, winEnv, thisPoint;
							startPoints = startPoints.asStream;
							rates = rates.asStream;
							winDur = winDur.asStream;
							overlaps = overlaps.asStream;
							baseFreq = baseFreq.asStream;
							freqMul = freqMul.asStream;
							loc = loc.asStream;
							winEnv = Env([0, 1, 1, 0], [0.2, 0.6, 0.2], \sin);
							loop({
								thisPoint = pevents.stamp(startPoints.next).postln + 10.0.rand;
								next = (noteDur = winDur.next) / overlaps.next;
								notes[\CSperc].new(target: group, server: server)
									.outbus_(routebus).buffer_(buffer).rate_(rates.next)
									.starttime_(thisPoint)
									.centerfreq_(baseFreq.next * freqMul.next).amp_(1)
									.dur_(noteDur).loc_(loc.next * 0.5pi).env_(winEnv).play;
								next.wait;
								})
						})	
					})
				};
				
			spotBP = {arg id, amp, env, outbus, startPoints, loc, rates, winDur, 
					overlaps, baseFreq, widths;
				ProcModR(env, amp, 4, bfBus1.bus, id, server: s1)
					.function_({arg group, routebus, server, pm;
						Task({
							var next, noteDur, winEnv, thisPoint;
							startPoints = startPoints.asStream;
							rates = rates.asStream;
							winDur = winDur.asStream;
							overlaps = overlaps.asStream;
							baseFreq = baseFreq.asStream;
							loc = loc.asStream;
							widths = widths.asStream;
							winEnv = Env([0, 1, 1, 0], [0.2, 0.6, 0.2], \sin);
							loop({
								thisPoint = pevents.stamp(startPoints.next) + 10.0.rand;
								next = (noteDur = winDur.next) / overlaps.next;
								notes[\CSspotlightBP].new(target: group, server: server)
									.outbus_(routebus).buffer1_(fluteBuf)
									.buffer2_(clarBuf).buffer3_(celloBuf).rate_(rates.next)
									.startPos_(thisPoint).cf_(baseFreq.next).pShift_(1)
									.width_(widths.next).amp_(1).dur_(noteDur)
									.loc_(loc.next * 0.5pi).env_(winEnv).play;
								next.wait;
								})	
							})
						})
				};
			
			/* ProcEvents */
			pevents = ProcEvents([
/*	0	*/		[nil, nil],
/*	1	*/		[nil, nil],
/*	2	*/		[
					[
						playbackPoint.(\ev2, prefs[\ev2Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \sin], 1), 
							bfBus1.bus, celloBuf, 1, 20),
						// turn on the filter... wait 2 seconds 
						filtCurChord.(\ev2a, prefs[\ev2aAmp].dbamp, 
							Env([0, 0, 1, 0], [1, 10, 10], \lin, 2), 
							bfBus2.bus, sumS2Bus, 0, 1, s2)
						],
					nil],
/*	3	*/		[
					playbackPoint.(\ev3, prefs[\ev3Amp].dbamp, 
						Env([0, 1, 0], [8, 8], [\sin, \lin], 1), 
						bfBus1.bus, celloBuf, 1, 50),
					\ev2],
/*	4	*/		[	
					filtCurChord.(\ev4a, prefs[\ev4aAmp].dbamp, 
						Env([0, 0, 1, 0], [1, 10, 10], \lin, 2), 
						bfBus1.bus, sumS1Bus, -0.2, 1, s1),
					nil],
/* PT5	*/		[nil, nil],
/*	6	*/		[nil, nil],
/*	7	*/		[		
					[
						playbackPoint.(\ev7, prefs[\ev7Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \sin], 1),
							bfBus1.bus, celloBuf, 6, 20),
						filtCurChord.(\ev7a, prefs[\ev7aAmp].dbamp, 
							Env([0, 0, 1, 0], [1, 10, 10], \lin, 2), 
							bfBus2.bus, sumS2Bus, 0.8, 1, s2)
						],
					nil],
/*	8	*/		[
					[
						playbackPoint.(\ev8, prefs[\ev8Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\sin, \lin], 1),
							bfBus1.bus, celloBuf, 6, 50),
						playbackPoint.(\ev8a, prefs[\ev8aAmp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \lin], 1),
							bfBus1.bus, celloBuf, 7, 10)
						],
					\ev7],
/*	9	*/		[	
					filtCurChord.(\ev9, prefs[\ev9Amp].dbamp, 
						Env([0, 0, 1, 0], [1, 10, 10], \lin, 2), 
						bfBus1.bus, sumS1Bus, 0.3, 1, s1), 
					nil],
/* PT10	*/		[nil, nil],
/*	11	*/		[nil, nil],
/*	12	*/		[
					[
						playbackPoint.(\ev12, prefs[\ev12Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \sin], 1), 
							bfBus1.bus, celloBuf, 11, 20),
						filtCurChord.(\ev12a, prefs[\ev12aAmp].dbamp, 
							Env([0, 0, 1, 0], [1, 10, 10], \lin, 2), 
							bfBus2.bus, sumS2Bus, -0.9, 1, s2), 
						], 
					\ev8a],
/*	13	*/		[
					playbackPoint.(\ev13, prefs[\ev13Amp].dbamp, 
						Env([0, 1, 0], [8, 8], [\sin, \lin], 1), 
						bfBus1.bus, celloBuf, 11, 45),
					[\ev3, \ev12]
					],
/*	14	*/		[
					[
						playbackPoint.(\ev14, prefs[\ev14Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \sin], 1), 
							bfBus1.bus, celloBuf, 13, 20),
						filtCurChord.(\ev14a, prefs[\ev14aAmp].dbamp, 
							Env([0, 0, 1, 0], [1, 10, 10], \lin, 2), 
							bfBus1.bus, sumS1Bus, -0.5, 1, s1) 
						], 
					nil],
/* PT15	*/		[nil, nil],
/*	16	*/		[
					playbackPoint.(\ev16, prefs[\ev16Amp].dbamp, 
						Env([0, 1, 0], [8, 8], [\sin, \lin], 1), 
						bfBus1.bus, celloBuf, 13, 40),
					\ev14],
/*	17	*/		[
					[
						playbackPoint.(\ev17, prefs[\ev17Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \sin], 1), 
							bfBus1.bus, celloBuf, 16, 20),
						filtCurChord.(\ev17a, prefs[\ev17aAmp].dbamp, 
							Env([0, 0, 1, 0], [1, 10, 10], \lin, 2), 
							bfBus2.bus, sumS2Bus, 0.7, 1, s2), 
						barkDel.(\ev17b, prefs[\ev17bAmp].dbamp, 
							Env([0, 1, 0], [60, 30], [5, -3], 1), 
							bfBus2.bus, 
							inbus: fluteS2Bus,
							winDur: (Pwhite(4.0, 8.0).asStream * Env([3, 1], [120]).asStream),
							overlaps: Pwhite(1.9, 2.1),
							freqMul: Pwhite(0.9, 1.1),
							loc: (Pwhite(-1.0, 1.0).asStream * Env([0, 1], [120]).asStream),
							width: (Pwhite(0.5, 0.8).asStream * Env([0.1, 1], [120]).asStream)
							)
						], 
					nil],
/*	18	*/		[
					[
						playbackPoint.(\ev18, prefs[\ev18Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\sin, \lin], 1), 
							bfBus1.bus, celloBuf, 16, 30),
						inHarm.(\ev18a, prefs[\ev18aAmp].dbamp, 
							Env([0, 1, 0], [40, 2], [5, -1], 1),
							outbus: bfBus2.bus, 
							inbus: clarS2Bus,	
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([-7, 3, 5, -5, 7, -12, 3], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(12.0, 14.0))
						], 
					[\ev8, \ev17]],
/*	19	*/		[
					[
						playbackPoint.(\ev19, prefs[\ev19Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \sin], 1), 
							bfBus1.bus, celloBuf, 18, 15),
						filtCurChord.(\ev19a, prefs[\ev19aAmp].dbamp, 
							Env([0, 0, 1, 0], [1, 10, 10], \lin, 2), 
							bfBus1.bus, sumS1Bus, -0.7, 1, s1),
						warpHarm.(\ev19b, prefs[\ev19bAmp].dbamp, 
							Env([0, 1, 0], [10, 10], [5, 1], 1),
							outbus: bfBus1.bus, 
							playPoint: 7, 
							pointRandSecs: 1, 
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([-7, 3, 5, -5, 7, -12, 3], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(12.0, 14.0))
						], 
					\ev13],
/* PT20	*/		[nil, nil],
/*	21	*/		[
					[
						playbackPoint.(\ev21, prefs[\ev21Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\sin, \lin], 1), 
							bfBus1.bus, celloBuf, 18, 30),
						warpHarm.(\ev21a, prefs[\ev21aAmp].dbamp, 
							Env([0, 1, 0], [10, 10], [5, 1], 1),
							outbus: bfBus1.bus, 
							playPoint: 17, 
							pointRandSecs: 1, 
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([-7, 3, 5, -5, 7, -12, 3], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(12.0, 14.0))
						], 
					[\ev19, \ev19b]],
/*	22	*/		[
					[
						playbackPoint.(\ev22, prefs[\ev22Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \lin], 1), 
							bfBus1.bus, celloBuf, 21, 30),
						warpHarm.(\ev22a, prefs[\ev22aAmp].dbamp, 
							Env([0, 1, 0], [10, 10], [5, 1], 1),
							outbus: bfBus1.bus,
							playPoint: 12, 
							pointRandSecs: 1, 
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([-7, 3, 5, -5, 7, -12, 3], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(12.0, 14.0))
						], 
					\ev21a],
/* PT23	*/		[nil, nil],
/*	24	*/		[
					[
						playbackPoint.(\ev24, prefs[\ev24Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \lin], 1), 
							bfBus1.bus, celloBuf, 22, 30),
						warpHarm.(\ev24a, prefs[\ev24aAmp].dbamp, 
							Env([0, 1, 0], [10, 10], [5, 1], 1),
							outbus: bfBus1.bus, 
							playPoint: 17, 
							pointRandSecs: 1, 
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([-7, 3, 5, -5, 7, -12, 3], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(12.0, 14.0)),
						barkDel.(\ev24b, prefs[\ev24bAmp].dbamp, 
							Env([0, 1, 0], [30, 30], [5, -3], 1), 
							bfBus2.bus,
							inbus: celloS2Bus,
							winDur: (Pwhite(4.0, 8.0).asStream * Env([3, 1], [60]).asStream),
							overlaps: Pwhite(1.9, 2.1),
							freqMul: Pwhite(0.9, 1.1),
							loc: (Pwhite(-1.0, 1.0).asStream * Env([0, 1], [60]).asStream),
							width: (Pwhite(0.5, 0.75).asStream * Env([0.1, 1], [60]).asStream)
							)
						], 
					\ev22a],
/*	25	*/		[nil, nil],
/*	26	*/		[
					playbackPoint.(\ev26, prefs[\ev26Amp].dbamp, 
						Env([0, 1, 0], [8, 8], [\lin, \lin], 1), 
						bfBus1.bus, celloBuf, 25, 20),
					nil],
/* PT27	*/		[nil, nil],
/*	28	*/		[
					playbackPoint.(\ev28, prefs[\ev28Amp].dbamp, 
						Env([0, 1, 0], [8, 8], [\lin, \lin], 1), 
						bfBus1.bus, celloBuf, 26, 30),
					\ev16],
/*	29	*/		[
					[
						playbackPoint.(\ev29a, prefs[\ev29aAmp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \lin], 1), 
							bfBus1.bus, celloBuf, 1, 50),
						playbackPoint.(\ev29b, prefs[\ev29bAmp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \lin], 1), 
							bfBus1.bus, celloBuf, 6, 50),
						playbackPoint.(\ev29c, prefs[\ev29cAmp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \lin], 1), 
							bfBus1.bus, celloBuf, 13, 30),
						perc.(\ev29d, prefs[\ev29dAmp].dbamp, 
							Env([0, 1, 0], [30, 8], [3, -3], 1), 
							bfBus1.bus, clarBuf, 
							startPoints: Pseq([18, 22, 24, 25, 26], inf), 
							loc: (Pwhite(-1.0, 1.0).asStream * Env([0, 1], [50]).asStream),
							rates: Env([1, 1.3], [50]),
							winDur: 8,
							overlaps: Env([2.5, 4], [50]),
							baseFreq: Pwhite(950, 1000),
							freqMul: Pseq([0.25, 0.615, 1.415, 0.75, 0.865], inf))
						], 
					\ev28],
/* PT30	*/		[nil, nil],
/*	31	*/		[	
					warpHarm.(\ev31a, prefs[\ev31aAmp].dbamp, Env([0, 1, 0], [5, 10], [5, 1], 1),
						outbus: bfBus1.bus, 
						playPoint: 12, 
						pointRandSecs: 1, 
						loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
						harms: Pseq([0, -12, 7], inf),
						overlaps: Pwhite(2.9, 3.1),
						winDur: Pwhite(6.0, 8.0)), 
					// last release of playbacks
					[\ev18, \ev21, \ev22, \ev24, \ev26, \ev29a, \ev29b, \ev29c]], 
/*	32	*/		[	
					[
						warpHarm.(\ev32a, prefs[\ev32aAmp].dbamp, 
							Env([0, 1, 1, 0], [5, 10, 30], [5, 0, -3]),
							outbus: bfBus1.bus, 
							playPoint: 2, 
							pointRandSecs: 1, 
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([0, -12, 7], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(6.0, 8.0)), 
						warpHarm.(\ev32b, prefs[\ev32bAmp].dbamp, 
							Env([0, 1, 1, 0], [5, 10, 50], [5, 0, -3]),
							outbus: bfBus1.bus, 
							playPoint: 7, 
							pointRandSecs: 1, 
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([0, -12, 7], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(6.0, 8.0))
						],
					[\ev17b, \ev18a, \ev24a, \ev24b, \ev29d, \ev31a]],
/* PT33	*/		[nil, nil],
/*	34	*/		[	
					[
						playbackPoint.(\ev34, prefs[\ev34Amp].dbamp, 
							Env([0, 1, 0], [8, 8], [\lin, \lin], 1), 
							bfBus1.bus, celloBuf, 1, 20), 
						spotBP.(\ev34a, prefs[\ev34aAmp].dbamp,
							Env([0, 1, 0], [60, 90], [3, -3], 1), 
							bfBus1.bus,
							startPoints: 
								Prand([8, 11, 13, 16, 18, 21, 22, 24, 25, 26, 28, 29], inf),
							loc: (Pwhite(-1.0, 1.0).asStream * Env([0, 1], [60]).asStream),
							rates: Pwhite(0.8, 1.2),
							winDur: (Pwhite(8.0, 16.0).asStream * 
								Env([1, 1.5], [60]).asStream),
							overlaps: Pwhite(2.5, 3.5),
							baseFreq: Prand([72, 75, 79, 80, 84, 87, 91].midicps, inf),
							widths: Pwhite(0.1, 0.2))
						],
						nil],
/*	35	*/		[	
					inHarm.(\ev35, prefs[\ev35Amp].dbamp, Env([0, 1, 0], [20, 40], [5, -3], 1),
						outbus: bfBus2.bus, 
						inbus: clarS2Bus,		
						loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
						harms: Pseq([-7, 3, 5, -5, 7, -12, 3], inf),
						overlaps: Pwhite(2.9, 3.1),
						winDur: Pwhite(12.0, 14.0)), 
					\ev34],
/* PT36	*/		[nil, nil],
/*	37	*/		[	
					[
						inHarm.(\ev37a, prefs[\ev37aAmp].dbamp, 
							Env([0, 1, 0], [20, 40], [5, -3], 1),
							outbus: bfBus2.bus, 
							inbus: fluteS2Bus,
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([-7, 3, 5, -5, 7, -12, 3], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(12.0, 14.0)),
						inHarm.(\ev37b, prefs[\ev37bAmp].dbamp, 
							Env([0, 1, 0], [40, 40], [5, -3], 1),
							outbus: bfBus2.bus, 
							inbus: celloS2Bus,	
							loc: Pshuf([-0.7, -0.3, 0, 0.3, 0.7], inf),
							harms: Pseq([7, 3, 12, -5, 5, -12, 3], inf),
							overlaps: Pwhite(2.9, 3.1),
							winDur: Pwhite(12.0, 14.0))
						],
					nil],
/*	38	*/		[	
					barkDel.(\ev38, prefs[\ev38Amp].dbamp, 
						Env([0, 1, 0], [30, 30], [5, -3], 1), 
						bfBus2.bus, 
						inbus: sumS2Bus,
						winDur: (Pwhite(4.0, 8.0).asStream * Env([3, 1], [60]).asStream),
						overlaps: Pwhite(2.9, 3.1),
						freqMul: Pwhite(0.9, 1.1),
						loc: (Pwhite(-1.0, 1.0).asStream * Env([0, 1], [60]).asStream),
						width: (Pwhite(0.5, 0.75).asStream * Env([0.1, 1], [60]).asStream)
						), 
					nil],
/* PT39	*/		[nil, nil],
/*	40	*/		[nil, nil],
/*	41	*/		[nil, [\ev38, \ev34a, \ev35, \ev37a, \ev37b]],
/*	42	*/		[nil, [\ev2a, \ev4a, \ev7a, \ev9, \ev12a, \ev14a, \ev17a, \ev19a]],
				], 
				1, init, kill, "Corpi Sonori");
				
			pevents.perfGUI;
			p = pevents;
			Button.new(pevents.window, pevents.window.view.children[5].bounds +
					(pevents.window.view.children[5].bounds - 
						pevents.window.view.children[4].bounds))
				.states_([
					["Open Prefs"] ++ pevents.window.view.children[5].states[0][1..2]
					])
				.font_(Font("Arial", 24))
				.action_({prefs.gui});
			pevents.eventArray.flat.do({arg sym;
				var event, ampPref, outPref;
				event = pevents.eventDict[sym];
				ampPref = prefs.prefsDict[(sym++"Amp").asSymbol];
				ampPref.action_({arg value; event.amp_(value.value.dbamp)});
//				outPref = prefs.prefsDict[(sym++"Out").asSymbol];
//				outPref.action_({arg value; event.procout_(value.value * 2)});
				});
			(scoreDisplay > 0).if({
				scoreWindow = Window.new("Corpi Sonori Score", 
					Rect(Window.screenBounds.width - 1190, 100, 1090, 800));
				scoreWindow.front;
				scoreWindow.view.keyDownAction_({arg view, char, modifiers, unicode, keycode;
					case
						{keycode == 49}
						{pevents.next}
						{keycode == 123 or: {keycode == 125}}
						{
							curPage = curPage - 1;
							(curPage > 0).if({
								image = slides[curPage - 1];
								scoreWindow.drawHook_({
									image.drawAtPoint(80@10, nil, operation, fraction);
									});
								scoreWindow.refresh
								}, {
								curPage = 1;
								})
							}
						{keycode == 124 or: {keycode == 126}}
						{
							curPage = curPage + 1;
							(curPage < 12).if({
								image = slides[curPage - 1];
								scoreWindow.drawHook_({
									image.drawAtPoint(80@10, nil, operation, fraction);
									});
								scoreWindow.refresh
								}, {
								curPage = 11;
								})
							}
					});
				image = slides[curPage - 1];
				scoreWindow.drawHook_({
					image.drawAtPoint(80@10, nil, operation, fraction);
					});
				scoreWindow.refresh;
				evNumDisp = NumberBox.new(scoreWindow, Rect(10, 300, 60, 60))
					.value_(start - 1)
					.font_(Font("Arial", 36))
					.action_({arg me; pevents.index_(me.value)});
				pevents.onEvent_({arg event;
					var lastPage;
					lastPage = curPage;
					curPage = scorePages[event];
					evNumDisp.value_(event);
					(lastPage != curPage).if({
						image = slides[curPage - 1];
						scoreWindow.drawHook_({
							image.drawAtPoint(80@10, nil, operation, fraction)});
						scoreWindow.refresh;
						});
					});
				})
			})
		})
	}, clock: AppClock)
)
/*

z = PreferencePane("Corpi Sonori", prefPath: "/Users/joshp/Documents/currentMusic/CorpiSonori/CopriSonoriPrefs.scd");


z.gui
y = 8.collect({arg i; (i+1).asString})
z.addPref(Preference(\fluteIn, 0, \menu, label: "Input Channel for flute", choices: y))
z.addPref(Preference(\fluteAmpScale, 0, \number, label: "Amp scale (in db) for the flute:"))
z.addPref(Preference(\clarIn, 0, \menu, label: "Input Channel for clarinet", choices: y))
z.addPref(Preference(\clarAmpScale, 0, \number, label: "Amp scale (in db) for the clarinet:"))
z.addPref(Preference(\celloIn, 0, \menu, label: "Input Channel for cello", choices: y))
z.addPref(Preference(\celloAmpScale, 0, \number, label: "Amp scale (in db) for the cello:"))
z.save


i = ["[0, 1]", "[2, 3]", "[4, 5]", "[6, 7]"];
p.eventArray.flat.do({arg sym;
	z.addPref(Preference((sym ++ "Out").asSymbol, 0, \menu, label: "Output Channels for event" + sym, choices: i));
	z.addPref(Preference((sym ++ "Amp").asSymbol, 0, \number, label: "Amp scale (in db) for event" + sym))
	})
	
z.addFile(String.scDir ++"/CorpiSonori.rtf")
	
pevets.eventArray.flat.do({arg sym;
	var event, ampPref, outPref;
	event = pevets.eventDict[sym];
	ampPref = prefs.prefsDict[(sym++"Amp").asSymbol];
	ampPref.action_({arg value; event.amp_(value.value.dbamp)});
	outPref = prefs.prefsDict[(sym++"Out").asSymbol];
	outPref.action_({arg value; event.procout_(value.value * 2)});
	});
	
	
	
z[\ev38Amp]
z[\ev38Out]

z.prefsDict.add(\ev34Amp -> z.prefsDict[\ev12Amp].deepCopy)

z.prefsDict[\ev34Amp].id_(\ev34Amp)

z.prefsDict.removeAt(\ev10aOut)


z.prefsDict.add(\ev28Out -> z.prefsDict[\ev12Out].deepCopy)

z.prefsDict[\ev28Out].id_(\ev28Out)

z.gui


z.prefs.do({arg me; 
	var id, label; 
	id = me.id.asString.postln;
	id = id.asString[2..(id.size-4)].postln;
	label = (me.label[0..(me.label.size-6)] + id).postln;
	me.label_(label)
	})

z.prefs[6..z.prefs.size-1].do({arg me; me.id.postln})


z.prefs[6].label[0..z.prefs]

z.saveAsArchive



z.prefs[25].label_("Amp scale (in db) for event 12")
z.prefs[27].label_("Amp scale (in db) for event 12a")
z.prefs[29].label_("Amp scale (in db) for event 13")



z.prefs[4].label_("Input Channel for Cello")
z.prefs[5].label_("Amp scale (in db) for the Cello")
*/
